Wednesday, December 31, 2014

2. Add Two Numbers LeetCode Java

You are given two linked lists representing two non-negative numbers. The digits are stored in reverse order and each of their nodes contain a single digit. Add the two numbers and return it as a linked list.
Input: (2 -> 4 -> 3) + (5 -> 6 -> 4)
Output: 7 -> 0 -> 8

Solution:
My solution is straightforward, as long as l1,l2 is not null or carry is non-zero, create a new ListNode by calculating the sum and updating the carry. This method require some attention of processing null-pointer. l1 and l2 are both possibly null when they are iterated. 
 public ListNode addTwoNumbers(ListNode l1, ListNode l2) {  
    if(l1==null && l2==null) return null;  
    ListNode predummy=new ListNode(0);  
    ListNode pre=predummy;  
    ListNode cur1=l1;  
    ListNode cur2=l2;  
    int sum=0;  
    int carry=0;  
    while(cur1!=null || cur2!=null || carry!=0){  
      int num1=(cur1==null)? 0: cur1.val;  
      int num2=(cur2==null)? 0: cur2.val;  
      sum=num1+num2+carry;  
      ListNode temp=new ListNode(sum%10);  
      pre.next=temp;  
      pre=pre.next;  
      carry=sum/10;  
      if(cur1!=null) cur1=cur1.next;  
      if(cur2!=null) cur2=cur2.next;  
    }  
    return predummy.next;  
   }  

1. Two sum leetcode Java

Two Sum

 Given an array of integers, find two numbers such that they add up to a specific target number.
The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.
You may assume that each input would have exactly one solution.
Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2

Solution:
Clearly, O(n^2) using brute force: check the sum of each pair of numbers in this array and see if the sum is equal to the target.
My O(n) solution is following:
Using a hashmap to record the visited number with its index, check if (target-current element) exist in the hashmap,if yes then the existing one is the first element, current element is the second element.

 public int[] twoSum(int[] numbers, int target) {  
    if (numbers==null || numbers.length<2) return null;  
    int[] res=new int[2];  
    HashMap<Integer,Integer> map=new HashMap<Integer,Integer>();  
    for(int i=0; i< numbers.length;i++){  
      if(map.containsKey(target-numbers[i])){  
        res[0]=map.get(target-numbers[i]);  
        res[1]=i+1;  
        return res;  
      }  
      map.put(numbers[i],i+1);  
    }  
    return res;  
   }